#!/usr/bin/env python3
"""
Debug 1
by Javantea
May 20, 2014

Based on fuzzing work I did year ago, but distinct and written from scratch.
This actually works. I can't think of the words to describe this. Let's fix Peach!
"""
import os, sys

def fork_exec(program, args=None, env=None, retSoon=False, devNull=False):
	if args == None:
		args = []
	#end if
	if env == None:
		env = {}
	#end if
	pid = os.fork()
	if pid == 0:
		# Child
		if devNull:
			os.close(sys.stdout.fileno())
			os.open('/dev/null', os.O_WRONLY)
			os.dup2(3, 1)
		#end if
		os.execve(program, args, env)
	else:
		if retSoon:
			# FIXME: Breaks the return type, but I can't give a sts if it isn't returned.
			return pid
		#end if
		pid, sts = os.waitpid(pid, 0)
		return (pid, sts)
	#end if
	return None
#end def fork_exec(program, [args], [env])

def wait_pid(pid):
	pid, sts = os.waitpid(pid, 0)
	return (pid, sts)
#end def wait_pid(pid)

def main():
	r = fork_exec('./crash1', ['./crash1'])
	if r == None:
		print("Failed to execute apparently.")
		return 1
	#end if
	pid, sts = r
	print("Now I have control again.", (pid, sts))
	if sts == 11:
		print("Segfault occurred.")
	#end if
#end def main()

if __name__ == '__main__':
	main()
#end if
